--[[
--	//////////////////////////////////////////////
--	Variables Init
--	//////////////////////////////////////////////
]]
local CharItem_VERSION		= "1.2.2";
local CharItem_PROVIDER		= "Wulfson";
local CharItem_PROFILEDB		= "1.2.2";
local CharItem_TITLE			= "CharacterItems (based on rpgo-CharacterProfiler 1.212)";
local CharItemdebug 			= nil;		-- [1|nil] enable debugging
--	//////////////////////////////////////////////
if(not rpgoColorTitle) then rpgoColorTitle = "909090"; end
if(not rpgoColorGreen) then rpgoColorGreen = "00cc00"; end
if(not rpgoColorRed)   then rpgoColorRed   = "ff0000"; end
myItems = {};
myItems[GetCVar("realmName")] = {} ;
--RegisterForSave("myItems");
CharItempref = {};
CharItempref["Enabled"]			= 1;
CharItempref["GetEquipment"]		= 1;	-- get equipment?
CharItempref["GetInventory"]		= 1;	-- get inventory?
CharItempref["GetBank"]			= 1;	-- get bank?
--CharItempref["HTML_Tooltips"]		= 1;	-- make html tooltips (non-array format) - separate lines with <br>

-- uncomment to CharItempref in sv.lua
--RegisterForSave("CharItempref");
-- or save CharItem_ENABLED
CharItem_ENABLED = CharItempref["Enabled"];
--RegisterForSave("CharItem_ENABLED");
--	//////////////////////////////////////////////
local CharItemlock = nil;
local CharItemplayer = nil;
local CharItemserver = nil;
local CharItemstate = {};
--	//////////////////////////////////////////////
local bagFirst = 0;
local bagLast = 4;
local bankTimeWait = 3;
local bankFirst = 5;
local bankLast = 10;
local equipmentCount = 19;
local timePlayed = -1;
local timeLevelPlayed = -1;

-- array of inventory slot names
Profile_slots = {
  "Head",          -- 1
  "Neck",          -- 2
  "Shoulder",      -- 3
  "Shirt",         -- 4
  "Chest",         -- 5
  "Waist",         -- 6
  "Legs",          -- 7
  "Feet",          -- 8
  "Wrist",         -- 9
  "Hands",         -- 10
  "Finger0",       -- 11
  "Finger1",       -- 12
  "Trinket0",      -- 13
  "Trinket1",      -- 14
  "Back",          -- 15
  "MainHand",      -- 16
  "SecondaryHand", -- 17
  "Ranged",        -- 18
  "Tabard",        -- 19
};

--[[//////////////////////////////////////////////
--	CharItem Core Functions
--    OnLoad,LoadVar,RegisterEvents,InitState,OnEvent
--	////////////////////////////////////////////]]

--[[// OnLoad
--	////////////////////////////////////////////]]
function CharItem_OnLoad()
	CharItem_InitState();
	this:RegisterEvent("VARIABLES_LOADED");
	SLASH_CharItem1 = "/ci";
	SLASH_CharItem2 = "/profiler";
	SlashCmdList["CharItem"] = CharItem_ChatCommand;
	DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE).." [v" .. CharItem_VERSION .. "] loaded.");
	CharItem_debug(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE).." running in DEBUG MODE.");
end

--[[// LoadVar
--	////////////////////////////////////////////]]
function CharItem_LoadVar()
	CharItempref["Enabled"] = CharItem_ENABLED;
	CharItem_RegisterEvents();
	CharItemstate["LoadedVar"] = 1;
	CharItemplayer = UnitName("player");
	CharItemserver = GetCVar("realmName");
	CharItem_InitProfile();
end

--[[// RegisterEvents
--	////////////////////////////////////////////]]
function CharItem_RegisterEvents()
	local flagMode=0;
	if(CharItempref["Enabled"]==1) then
		flagMode=1;
	end
	if(flagMode==1) then
		CharItem_debug("     RegisterEvents");
		CharItemframe:RegisterEvent("PLAYER_ENTERING_WORLD");
		CharItemframe:RegisterEvent("PLAYER_LEVEL_UP");
		CharItemframe:RegisterEvent("TIME_PLAYED_MSG");
		CharItemframe:RegisterEvent("BANKFRAME_CLOSED");
		CharItemframe:RegisterEvent("MAIL_CLOSED");
		CharItemframe:RegisterEvent("MERCHANT_CLOSED");
	else
		CharItem_debug("     UnregisterEvent");
		CharItemframe:UnregisterEvent("PLAYER_ENTERING_WORLD");
		CharItemframe:UnregisterEvent("PLAYER_LEVEL_UP");
		CharItemframe:UnregisterEvent("TIME_PLAYED_MSG");
		CharItemframe:UnregisterEvent("BANKFRAME_CLOSED");
		CharItemframe:UnregisterEvent("MAIL_CLOSED");
		CharItemframe:UnregisterEvent("MERCHANT_CLOSED");
	end
	flagMode=nil;
end

--[[// InitState
--	////////////////////////////////////////////]]
function CharItem_InitState(arg)
	CharItemstate={};
	CharItemstate["Loaded"]=nil;
	CharItemstate["LoadedVar"]=arg;
	CharItemstate["Equipment"]=0;
	CharItemstate["EquipmentScan"]=0;
	CharItemstate["Guild"]=nil;
	CharItemstate["GuildNum"]=nil;
	CharItemstate["Inventory"]={};
	CharItemstate["Bank"]={};
	CharItemstate["BankTime"]=0;
end

--[[// OnEvent
--	////////////////////////////////////////////]]
function CharItem_OnEvent(event,arg1,arg2,arg3,arg4,arg5)
	if(rpgoDebugArg) then rpgoDebugArg("CP",event,arg1,arg2,arg3,arg4,arg5); end
	if(event=="VARIABLES_LOADED") then
		CharItem_LoadVar();
		return;
	end
	if(CharItempref["Enabled"]==0) then return; end
	if(event=="TIME_PLAYED_MSG") then
		return;
	elseif(event=="PLAYER_ENTERING_WORLD") then
		CharItem_LoadProfile();
		return;
	end

	if(not CharItemlock and CharItemplayer) then
		CharItemlock = 1;
		if(not CharItemstate["Loaded"]) then
			CharItem_LoadProfile();
		end
		if(event=="BANKFRAME_CLOSED") then
			CharItem_GetBank();
			CharItem_GetEquipment();
			CharItem_GetInventory();
		elseif(event=="MAIL_CLOSED") then
			CharItem_GetEquipment();
			CharItem_GetInventory();
		elseif(event=="MERCHANT_CLOSED") then
			CharItem_GetEquipment();
			CharItem_GetInventory();
		elseif(event=="PLAYER_LEVEL_UP") then
			CharItem_LoadProfile();
		end
		CharItemlock = nil;
	end
end

--[[// OnClick
--	////////////////////////////////////////////]]
function CharItem_OnClick()
	if(CharItempref["Enabled"]==0) then return; end
	if(not CharItemlock) then
		CharItemlock = 1;
		CharItem_ForceExport();
		CharItemlock = nil;
	end
	CharItem_Show();
end

--[[// OnHide
--	////////////////////////////////////////////]]
function CharItem_OnHide()
	if(CharItempref["Enabled"]==0) then return; end
	CharItem_InitProfile();
	CharItem_LoadProfile();
	CharItem_UpdateProfile();
end

--[[// OverLoaded functions are bad, but force till
--     PLAYER_QUITTING/PLAYER_LEAVING_WORLD
--     PetAbandon - to grab drop of pet
--	////////////////////////////////////////////]]
rpgoOldQuit = Quit;
function Quit()
	CharItem_UpdateProfile();
	RequestTimePlayed();
	return rpgoOldQuit();
end

rpgoOldLogout = Logout;
function Logout()
	CharItem_UpdateProfile();
	RequestTimePlayed();
	return rpgoOldLogout();
end

--[[// ChatCommand
--	////////////////////////////////////////////]]
function CharItem_ChatCommand(msg)
	if (msg) then
		msg = string.lower(msg);
		if (msg == "off") then
			CharItem_Toggle(0);
			return;
		elseif (msg == "on") then
			CharItem_Toggle(1);
			return;
		elseif (msg == "show") then
			CharItem_Show();
			return;
		elseif (msg == "export") then
			CharItem_ForceExport();
			return;
		elseif (msg == "debug") then
			CharItem_Debug();
			return;
		elseif (msg == "purge char") then
			CharItem_Purge("char");
			return;
		elseif (msg == "purge server") then
			CharItem_Purge("server");
			return;
		elseif (msg == "purge all") then
			CharItem_Purge("all");
			return;
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE).." Usage [v" .. CharItem_VERSION .. "]");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci          -- This Message");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci on       -- Turns CharacterItems on");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci off      -- Turns CharacterItems off");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci export");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci show");
	DEFAULT_CHAT_FRAME:AddMessage("   /ci purge [all|server|char]");
	if( CharItempref["Enabled"] == 1) then
		DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": currently "..rpgo_ColorizeMsg(rpgoColorGreen,"enabled"));
	else
		DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": currently "..rpgo_ColorizeMsg(rpgoColorRed,"disabled"));
	end
end

--[[// Toggle
--	////////////////////////////////////////////]]
function CharItem_Toggle(toggle)
	if (toggle == 1) then
		CharItem_InitState(1);
		CharItempref["Enabled"]=1;
		CharItem_RegisterEvents(CharItempref["Enabled"]);
		if (not CharItemplayer or CharItemserver) then
			CharItemplayer = UnitName("player");
			CharItemserver = GetCVar("realmName");
		end
		if (not CharItemstate["Loaded"]) then
			PaperDollFrame_SetDamage();
			PaperDollFrame_SetRangedDamage();
			CharItem_InitProfile();
			RequestTimePlayed();
		end
		DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": "..rpgo_ColorizeMsg(rpgoColorGreen,"enabled"));
	else
		CharItemstate = nil;
		CharItempref["Enabled"] = 0;
		CharItem_RegisterEvents(CharItempref["Enabled"]);
		DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": "..rpgo_ColorizeMsg(rpgoColorRed,"disabled"));
	end
	CharItem_ENABLED = CharItempref["Enabled"];
--	if ( (CharItempref["Enabled"] == 0) and myItems[CharItemserver] ) then
--		myItems[CharItemserver][CharItemplayer] = nil;
--	end
end

--[[// Debug
--	////////////////////////////////////////////]]
function CharItem_Debug()
	if (CharItemdebug) then
		CharItemdebug = nil;
	else
		CharItemdebug = 1;
		CharItem_debug("Debug Mode: enabled");
	end
end

--[[// Show
--	////////////////////////////////////////////]]
function CharItem_Show()
	if( CharItempref["Enabled"] == 1) then
		if(CharItemplayer and CharItemstate["Loaded"]) then
			local msg = "";
			local item=nil;
			local count=0;
			DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..":  character info scanned this session");

				msg="Profile for: " .. CharItemplayer .. "@" .. CharItemserver;
			DEFAULT_CHAT_FRAME:AddMessage("    "..msg);
			
				msg="Guild Info:  ";
				if(CharItemstate["Guild"] == 0) then
					msg=msg.."not in a guild";
				elseif(CharItemstate["Guild"]) then
					if(myItems[CharItemserver][CharItemplayer]["Guild"]["GuildName"]) then
						msg=msg..myItems[CharItemserver][CharItemplayer]["Guild"]["GuildName"];
					else
						msg=msg..rpgo_ColorizeMsg(rpgoColorRed," not scanned1");
					end
				else
					msg=msg..rpgo_ColorizeMsg(rpgoColorRed," not scanned2");
				end
			DEFAULT_CHAT_FRAME:AddMessage("    " .. msg);
			
				msg = "";
				msg = msg .. "  Equipment:"..CharItemstate["Equipment"].."/"..equipmentCount;
			DEFAULT_CHAT_FRAME:AddMessage("  " .. msg);

				count=0;
				msg = "Inventory:";
				for item in CharItemstate["Inventory"] do
					msg = msg .. " Bag" .. item..":"..CharItemstate["Inventory"][item]["inv"].."/"..CharItemstate["Inventory"][item]["slot"];
					count=count+1;
				end
				if(count==0) then
					msg=msg..rpgo_ColorizeMsg(rpgoColorRed," not scanned")..".   to scan: open your bank or 'character info'";
				end
			DEFAULT_CHAT_FRAME:AddMessage("    " .. msg);
			
				count=0;
				msg = "Bank:";
				for item in CharItemstate["Bank"] do
					msg = msg .. " Bag" .. item .. ":".. CharItemstate["Bank"][item]["inv"].."/"..CharItemstate["Bank"][item]["slot"];
					count=count+1;
				end
				if(count==0) then
					msg=msg..rpgo_ColorizeMsg(rpgoColorRed," not scanned")..".   to scan: open your bank (May have scanned, this is buggy)";
				end
			DEFAULT_CHAT_FRAME:AddMessage("    " .. msg);
			
		else
			DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": "..rpgo_ColorizeMsg(rpgoColorRed," no character scanned"));
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(rpgo_ColorizeTitle(CharItem_PROVIDER,CharItem_TITLE)..": currently "..rpgo_ColorizeMsg(rpgoColorRed,"disabled"));
	end
end

--[[//////////////////////////////////////////////
--	InitProfile
--	////////////////////////////////////////////]]
function CharItem_InitProfile()
	if ( not myItems ) then
		myItems = {};
	end
	if ( not myItems[CharItemserver] ) then
		myItems[CharItemserver] = {};
	end
	if ( not myItems[CharItemserver][CharItemplayer] ) then
		myItems[CharItemserver][CharItemplayer] = {};
	end
end

--[[//////////////////////////////////////////////
--	LoadProfile
--	////////////////////////////////////////////]]
function CharItem_LoadProfile()
	if(myItems[CharItemserver][CharItemplayer]["ProfilerProvider"]) then
		myItems[CharItemserver][CharItemplayer]["ProfilerProvider"]=nil;
	end

	local myGold,mySilver,myCopper = rpgoGetMoney();
	myItems[CharItemserver][CharItemplayer]["Money"] = {};
	myItems[CharItemserver][CharItemplayer]["Money"]["Gold"] = myGold;
	myItems[CharItemserver][CharItemplayer]["Money"]["Silver"] = mySilver;
	myItems[CharItemserver][CharItemplayer]["Money"]["Copper"] = myCopper;

	CharItem_GetGuild();
	CharItem_UpdateDate();
	CharItemstate["Loaded"] = 1;
end

--[[//////////////////////////////////////////////
--	UpdateProfile
--	////////////////////////////////////////////]]
function CharItem_UpdateProfile()
	CharItem_GetGuild(force);
	CharItem_GetEquipment();
	CharItem_GetInventory();
	CharItem_UpdateDate();
end

--[[//////////////////////////////////////////////
--	ForceExport
--	////////////////////////////////////////////]]
function CharItem_ForceExport()
	if(CharItempref["Enabled"]==0) then return; end
	local bankStateTemp = CharItemstate["Bank"];
	CharItem_InitState(1);
	CharItemstate["Bank"] = bankStateTemp;
	CharItem_InitProfile();
	CharItem_LoadProfile();
	CharItem_UpdateProfile();
end

--[[//////////////////////////////////////////////
--	Purge
--	////////////////////////////////////////////]]
function CharItem_Purge(arg1)
	if(arg1 and arg1 == "char") then
		myItems[CharItemserver][CharItemplayer] = {};
	elseif(arg1 and arg1 == "server") then
		myItems[CharItemserver] = {};
	elseif(arg1 and arg1 == "all") then
		myItems = {};
	end
	CharItem_InitState(1);
end

--[[//////////////////////////////////////////////
--	CharItem Extract functions
--	////////////////////////////////////////////]]
function CharItem_GetGuild(force)
	local isGuildMember = IsInGuild();
	if(not isGuildMember) then
		CharItemstate["Guild"] = 0;
	else
		local guildNumMembers = GetNumGuildMembers();
		if(force or not CharItemstate["Guild"] or CharItemstate["GuildNum"] ~= guildNumMembers) then
			myItems[CharItemserver][CharItemplayer]["Guild"] = {} ;
			local tmpGuildName,tmpGuildTitle,tmpGuildRank = GetGuildInfo("player");
			if(tmpGuildName) then
				myItems[CharItemserver][CharItemplayer]["Guild"]["GuildName"] = tmpGuildName;
				CharItemstate["Guild"] = 1;
				CharItemstate["GuildNum"] = guildNumMembers;
			end
		end
	end
end

function CharItem_GetEquipment(force)
	if( CharItempref["GetEquipment"] ) then
		if( force or CharItemstate["Equipment"]==0 or CharItemstate["Equipment"]~=CharItemstate["EquipmentScan"] ) then
			local link;
			local texture;
			CharItemstate["Equipment"]=0;
			CharItemstate["EquipmentScan"]=0;
			myItems[CharItemserver][CharItemplayer]["Equipment"] = {};
			for index,slot in Profile_slots do
				link = GetInventoryItemLink("player", index);
				texture = GetInventoryItemTexture("player", index);
				if(link) then
					local color,itemlink,item,name = CharItem_GetItemInfo(link);
					if( color~="" and item~="" and name~="" ) then
						myItems[CharItemserver][CharItemplayer]["Equipment"][slot] = { };
						myItems[CharItemserver][CharItemplayer]["Equipment"][slot]["Texture"] = texture;
						myItems[CharItemserver][CharItemplayer]["Equipment"][slot]["Color"] = color;
						myItems[CharItemserver][CharItemplayer]["Equipment"][slot]["Name"] = name;
						ProfileHiddenTooltip:SetInventoryItem("player", index);
						myItems[CharItemserver][CharItemplayer]["Equipment"][slot]["Tooltip"] = strTooltip();
						CharItemstate["EquipmentScan"]=CharItemstate["EquipmentScan"]+1;
					end
					CharItemstate["Equipment"]=CharItemstate["Equipment"]+1;
				end
			end
		end
	end
end

function CharItem_GetInventory()
	if( CharItempref["GetInventory"] ) then
		local playerSlotSkew=19;
		local bag;
		if(not myItems[CharItemserver][CharItemplayer]["Inventory"]) then
			myItems[CharItemserver][CharItemplayer]["Inventory"] = {};
			CharItemstate["Inventory"]={};
		end
		for bag=0,4 do
			local bagname, link, texture, color, item, itemname;
			bagname=GetBagName(bag);
			link=GetInventoryItemLink("player", (bag+playerSlotSkew));
			texture = GetInventoryItemTexture("player", (bag+playerSlotSkew));
			if(bag==0) then
				item=bagname;
				link="["..bagname.."]";
				color="ffffffff";
				texture="Interface\\Buttons\\Button-Backpack-Up";
				ProfileHiddenTooltip:SetText(bagname);
			elseif(link) then
				color,itemlink,item,itemname=CharItem_GetItemInfo(link);
				ProfileHiddenTooltip:SetInventoryItem("player",(bag+playerSlotSkew))
			end
			if( color and item and bagname ) then
				local bagContentsTemp=nil;
				if(myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag] and myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"]) then
					bagContentsTemp = myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"];
				end
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag] = {};
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Name"]=bagname;
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Slots"]=GetContainerNumSlots(bag);
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Color"]=color;
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Texture"]=texture;
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Tooltip"] = strTooltip();
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"]=bagContentsTemp;
				bagContentsTemp = nil;
				CharItem_GetBagItems(bag);
			else
				myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]=nil;
			end
		end
	elseif ( myItems[CharItemserver][CharItemplayer] ) then
		myItems[CharItemserver][CharItemplayer]["Inventory"] = nil;
		CharItemstate["Inventory"]={};
	end
end

function CharItem_GetBank()
	if( CharItempref["GetBank"]) then
		if( CharItemstate["BankTime"] < GetTime()-bankTimeWait) then
			if(not myItems[CharItemserver][CharItemplayer]["Bank"]) then
				myItems[CharItemserver][CharItemplayer]["Bank"]={};
				CharItemstate["Bank"]={};
			end
			local bagnum=0;
			local bagContentsTemp=nil;
			if(myItems[CharItemserver][CharItemplayer]["Bank"]["Contents"]) then
				bagContentsTemp=myItems[CharItemserver][CharItemplayer]["Bank"]["Contents"];
			end
			if(not CharItemstate["Bank"][bagnum] or not CharItemstate["Bank"][bagnum]["key"] or CharItemstate["Bank"][bagnum]["key"]~=CharItem_GetBagKey(BANK_CONTAINER)) then
				myItems[CharItemserver][CharItemplayer]["Bank"]["Contents"] = CharItem_GetBankBagItems(0,0);
			else
				myItems[CharItemserver][CharItemplayer]["Bank"]["Contents"]=bagContentsTemp;
				bagContentsTemp=nil;
			end
			local bag, size, slot, link;
			for bag=bankFirst,bankLast do
				bagnum = bag-4;
				bagName = "Bag" .. bagnum;
				link = GetContainerItemLink(BANK_CONTAINER, (bag+20));
				texture, itemCount, locked, quality = GetContainerItemInfo(BANK_CONTAINER, (bag+20));
				if(link) then
					color, itemlink, item, bagname=CharItem_GetItemInfo(link);
					if( color~="" and item~="" and bagname~="" ) then
						bagContentsTemp=nil;
						if(myItems[CharItemserver][CharItemplayer]["Bank"][bagName] and myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Contents"]) then
							bagContentsTemp=myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Contents"];
						end
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName] = {};
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Name"] = bagname;
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Slots"] = GetContainerNumSlots(bag);
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Texture"] = texture;
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Color"] = color;
						ProfileHiddenTooltip:SetHyperlink("item:" .. item);
						myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Tooltip"] = strTooltip();
						if(not CharItemstate["Bank"][bagnum] or not CharItemstate["Bank"][bagnum]["key"] or CharItemstate["Bank"][bagnum]["key"]~=CharItem_GetBagKey(bag)) then
							myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Contents"]=CharItem_GetBankBagItems(bag,bagnum);
						else
							myItems[CharItemserver][CharItemplayer]["Bank"][bagName]["Contents"]=bagContentsTemp;
							bagContentsTemp=nil;
						end
					end
				else
					CharItemstate["Bank"][bagnum]=nil;
					myItems[CharItemserver][CharItemplayer]["Bank"][bagName]=nil;
				end
			end
			CharItemstate["BankTime"]=GetTime();
		end
	elseif ( myItems[CharItemserver][CharItemplayer] ) then
		myItems[CharItemserver][CharItemplayer]["Bank"] = nil;
		CharItemstate["Bank"]={};
	end
end

function CharItem_GetBagItems(bag)
	if(not CharItemstate["Inventory"][bag] or not CharItemstate["Inventory"][bag]["key"] or CharItemstate["Inventory"][bag]["key"]~=CharItem_GetBagKey(bag)) then
		CharItemstate["Inventory"][bag]={};
		CharItemstate["Inventory"][bag]["inv"]=0;
		CharItemstate["Inventory"][bag]["slot"]=0;
		CharItemstate["Inventory"][bag]["key"]=0;
		local key=0;
		local slot, strings, str, texture, itemCount, locked, quality, link, color, item, name;
		myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"] = {};
		for slot=1,GetContainerNumSlots(bag) do
			ProfileHiddenTooltip:SetBagItem(bag, slot);
			texture, itemCount, locked, quality = GetContainerItemInfo(bag,slot);
			link = GetContainerItemLink(bag, slot);
			if(link) then
				color,itemlink,item,itemname=CharItem_GetItemInfo(link);
				if( color~="" and item~="" and itemname~="" ) then
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot] = {};
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot]["Tooltip"] = strTooltip();
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot]["Texture"] = texture;
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot]["Quantity"] = itemCount;
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot]["Name"] = itemname;
					myItems[CharItemserver][CharItemplayer]["Inventory"]["Bag" .. bag]["Contents"][slot]["Color"] = color;
					key=key+CharItem_CalcItemKey(itemCount,quality,slot);
				end
				CharItemstate["Inventory"][bag]["inv"]=CharItemstate["Inventory"][bag]["inv"]+1;
			end
			CharItemstate["Inventory"][bag]["slot"]=CharItemstate["Inventory"][bag]["slot"]+1;
		end
		CharItemstate["Inventory"][bag]["key"]=key;
	end
end

function CharItem_GetBankBagItems(bag,bagnum)
	local bagContents = {};
	local key=0;
	if(bag==0) then
		bagContainer=BANK_CONTAINER;
	else
		bagContainer=bag;
	end
	CharItemstate["Bank"][bagnum]={};
	CharItemstate["Bank"][bagnum]["slot"]=0;
	CharItemstate["Bank"][bagnum]["inv"]=0;
	CharItemstate["Bank"][bagnum]["key"]=0;
	for slot=1, GetContainerNumSlots(bagContainer) do
		local link = GetContainerItemLink(bagContainer, slot);
		local texture, itemCount, locked, quality = GetContainerItemInfo(bagContainer,slot);
		if( link ) then
			color, itemlink, item, name=CharItem_GetItemInfo(link);
			if( color~="" and item~="" and name~="" ) then
				bagContents[slot] = {};
				bagContents[slot]["Texture"] = texture;
				bagContents[slot]["Quantity"] = itemCount;
				bagContents[slot]["Name"] = name;
				bagContents[slot]["Color"] = color;
				if(bag==0) then
					ProfileHiddenTooltip:SetHyperlink("item:" .. item);
				else
					ProfileHiddenTooltip:SetBagItem(bag, slot);
				end
				bagContents[slot]["Tooltip"] = strTooltip();
				key=key+CharItem_CalcItemKey(itemCount,quality,slot);
			end
			CharItemstate["Bank"][bagnum]["inv"] = CharItemstate["Bank"][bagnum]["inv"]+1;
		end
		CharItemstate["Bank"][bagnum]["slot"] = CharItemstate["Bank"][bagnum]["slot"]+1;
	end
	CharItemstate["Bank"][bagnum]["key"]=key;
	return bagContents;
end

function CharItem_UpdateDate()
	myItems[CharItemserver][CharItemplayer]["DateUpdated"] = date();
end

--[[//////////////////////////////////////////////
--	general functions
--	////////////////////////////////////////////]]
function CharItem_GetBagKey(bag)
	local key=0;
	local slot,texture,itemCount,locked,quality;
	for slot = 1,GetContainerNumSlots(bag) do
		texture,itemCount,locked,quality = GetContainerItemInfo(bag,slot);
		if(itemCount and quality) then
			key=key+CharItem_CalcItemKey(itemCount,quality,slot);
		end
	end
	return(key);
end

function CharItem_GetItemInfo(link)
	local c,l,i,n;
	if(link) then _,_,c,l,i,n=string.find(link,"|c(%x+)|H(item:(%d+:%d+:%d+:%d+))|h%[(.-)%]|h|r"); end
	return c,l,i,n;
end

function CharItem_CalcItemKey(c,q,s)
	return((c*q)+s);
end

function rpgoGetMoney()
	local money = GetMoney();
	local gold,silver,copper;
	local CopperPerGold = COPPER_PER_SILVER * SILVER_PER_GOLD;
	gold = floor(money/CopperPerGold);
		money=mod(money,CopperPerGold);
	silver = floor(money/COPPER_PER_SILVER);
		money=mod(money,CopperPerGold);
	copper = mod(money,COPPER_PER_SILVER);
	return gold,silver,copper
end

function strTooltip()
	tooltipName = "ProfileHiddenTooltip";
	tooltipFrame = getglobal(tooltipName);
	local str = {};
	for i=1,tooltipFrame:NumLines() do
		local tipTemp = nil;
		tipText = getglobal(tooltipName .. "TextLeft" .. i);
		if(tipText and tipText:IsShown() and tipText:GetText()) then
			tipTemp = tipText:GetText();
			tipTemp = string.gsub(tipTemp, "\n", "<br>");
			tipTemp = string.gsub(tipTemp, "\r", "");
		end
		tipText = getglobal(tooltipName .. "TextRight" .. i);
		if(tipText and tipText:IsShown() and tipText:GetText()) then
			tipTemp = tipTemp .. "\t" .. tipText:GetText();
		end
		if(tipTemp) then table.insert(str, tipTemp); end
	end
	tooltipFrame:ClearLines();
	return table.concat(str,"<br>");
end

-- From CosmosCommonFunctions.lua
-- Clears a tooltip for usage.
function ClearTooltip(TooltipNameBase)
	for i=1, 15, 1 do
		getglobal(TooltipNameBase.."TextLeft"..i):SetText("");
		getglobal(TooltipNameBase.."TextRight"..i):SetText("");
	end
end

-- From CosmosCommonFunctions.lua
-- Gets all lines out of a tooltip.
function ScanTooltip(TooltipNameBase)
	if ( TooltipNameBase == nil ) then
		TooltipNameBase = "ProfileHiddenTooltip";
	end

	local strings = {};
	for idx = 1, 20 do
		local textLeft = nil;
		local textRight = nil;
		ttext = getglobal(TooltipNameBase.."TextLeft"..idx);
		if(ttext and ttext:IsVisible() and ttext:GetText() ~= nil)
		then
			textLeft = ttext:GetText();
		end
		ttext = getglobal(TooltipNameBase.."TextRight"..idx);
		if(ttext and ttext:IsVisible() and ttext:GetText() ~= nil)
		then
			textRight = ttext:GetText();
		end
		if (textLeft or textRight)
		then
			strings[idx] = {};
			strings[idx].left = textLeft;
			strings[idx].right = textRight;
		end
	end
	return strings;
end

if (not fixnilempty) then
	fixnilempty = function(...)
	  for i=1, arg.n, 1 do
	    if(not arg[i]) then
	      arg[i] = "";
	    end
	  end
	  return arg;
	end
end

function round(x)
  if(x - math.floor(x) > 0.5) then
    x = x + 0.5;
  end
  return math.floor(x);
end

--[[//////////////////////////////////////////////
--	general rpgo functions
--	////////////////////////////////////////////]]
-- USAGE: CharItem_debug(msg)
function CharItem_debug(msg)
	if (CharItemdebug) then
		if(rpgoDebug) then rpgoDebug("CP",msg);
		else DEFAULT_CHAT_FRAME:AddMessage("CharItem: [" .. msg .. "]",1,0,0); end
	end
end
-- USAGE: rpgo_ColorizeTitle(provider,title)
if (not rpgo_ColorizeTitle) then rpgo_ColorizeTitle=function(provider,title) if(provider and title) then return rpgo_ColorizeMsg(rpgoColorTitle,provider.."-"..title); end end end
-- USAGE: rpgo_ColorizeMsg(color,msg)
if (not rpgo_ColorizeMsg) then rpgo_ColorizeMsg=function(color,msg) if(color and msg) then return "|cff"..color..msg.."|r"; end end end
